io.vertx.rxjava.ext.mongo

## Class MongoClient

- java.lang.Object
- - io.vertx.rxjava.ext.mongo.MongoClient

- Direct Known Subclasses:
    MongoService

      public class MongoClient
      extends Object

  A Vert.x service used to interact with MongoDB server instances.

  Some of the operations might change _id field of passed document.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static io.vertx.lang.rx.TypeArg<MongoClient>` | `__TYPE_ARG`
    `static String` | `DEFAULT_DB_NAME` The name of the default database
    `static String` | `DEFAULT_POOL_NAME` The name of the default pool

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MongoClient(MongoClient delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `ReadStream<JsonObject>` | `aggregate(String collection, JsonArray pipeline)` Run aggregate MongoDB command with default `AggregateOptions`.
    `ReadStream<JsonObject>` | `aggregateWithOptions(String collection, JsonArray pipeline, AggregateOptions options)` Run aggregate MongoDB command.
    `MongoClient` | `bulkWrite(String collection, List<BulkOperation> operations, Handler<AsyncResult<MongoClientBulkWriteResult>> resultHandler)` Execute a bulk operation.
    `Observable<MongoClientBulkWriteResult>` | `bulkWriteObservable(String collection, List<BulkOperation> operations)` Deprecated. use `rxBulkWrite(java.lang.String, java.util.List<io.vertx.ext.mongo.BulkOperation>)` instead
    `MongoClient` | `bulkWriteWithOptions(String collection, List<BulkOperation> operations, BulkWriteOptions bulkWriteOptions, Handler<AsyncResult<MongoClientBulkWriteResult>> resultHandler)` Execute a bulk operation with the specified write options.
    `Observable<MongoClientBulkWriteResult>` | `bulkWriteWithOptionsObservable(String collection, List<BulkOperation> operations, BulkWriteOptions bulkWriteOptions)` Deprecated. use `rxBulkWriteWithOptions(java.lang.String, java.util.List<io.vertx.ext.mongo.BulkOperation>, io.vertx.ext.mongo.BulkWriteOptions)` instead
    `void` | `close()` Close the client and release its resources
    `MongoClient` | `count(String collection, JsonObject query, Handler<AsyncResult<Long>> resultHandler)` Count matching documents in a collection.
    `Observable<Long>` | `countObservable(String collection, JsonObject query)` Deprecated. use `rxCount(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `createCollection(String collectionName, Handler<AsyncResult<Void>> resultHandler)` Create a new collection
    `Observable<Void>` | `createCollectionObservable(String collectionName)` Deprecated. use `rxCreateCollection(java.lang.String)` instead
    `MongoClient` | `createIndex(String collection, JsonObject key, Handler<AsyncResult<Void>> resultHandler)` Creates an index.
    `Observable<Void>` | `createIndexObservable(String collection, JsonObject key)` Deprecated. use `rxCreateIndex(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `createIndexWithOptions(String collection, JsonObject key, IndexOptions options, Handler<AsyncResult<Void>> resultHandler)` Creates an index.
    `Observable<Void>` | `createIndexWithOptionsObservable(String collection, JsonObject key, IndexOptions options)` Deprecated. use `rxCreateIndexWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.IndexOptions)` instead
    `static MongoClient` | `createNonShared(Vertx vertx, JsonObject config)` Create a Mongo client which maintains its own data source.
    `static MongoClient` | `createShared(Vertx vertx, JsonObject config)` Like `createShared(io.vertx.rxjava.core.Vertx, io.vertx.core.json.JsonObject, java.lang.String)` but with the default data source name
    `static MongoClient` | `createShared(Vertx vertx, JsonObject config, String dataSourceName)` Create a Mongo client which shares its data source with any other Mongo clients created with the same data source name
    `MongoClient` | `distinct(String collection, String fieldName, String resultClassname, Handler<AsyncResult<JsonArray>> resultHandler)` Gets the distinct values of the specified field name.
    `ReadStream<JsonObject>` | `distinctBatch(String collection, String fieldName, String resultClassname)` Gets the distinct values of the specified field name.
    `ReadStream<JsonObject>` | `distinctBatchWithQuery(String collection, String fieldName, String resultClassname, JsonObject query)` Gets the distinct values of the specified field name filtered by specified query.
    `ReadStream<JsonObject>` | `distinctBatchWithQuery(String collection, String fieldName, String resultClassname, JsonObject query, int batchSize)` Gets the distinct values of the specified field name filtered by specified query.
    `Observable<JsonArray>` | `distinctObservable(String collection, String fieldName, String resultClassname)` Deprecated. use `rxDistinct(java.lang.String, java.lang.String, java.lang.String)` instead
    `MongoClient` | `distinctWithQuery(String collection, String fieldName, String resultClassname, JsonObject query, Handler<AsyncResult<JsonArray>> resultHandler)` Gets the distinct values of the specified field name filtered by specified query.
    `Observable<JsonArray>` | `distinctWithQueryObservable(String collection, String fieldName, String resultClassname, JsonObject query)` Deprecated. use `rxDistinctWithQuery(java.lang.String, java.lang.String, java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `dropCollection(String collection, Handler<AsyncResult<Void>> resultHandler)` Drop a collection
    `Observable<Void>` | `dropCollectionObservable(String collection)` Deprecated. use `rxDropCollection(java.lang.String)` instead
    `MongoClient` | `dropIndex(String collection, String indexName, Handler<AsyncResult<Void>> resultHandler)` Drops the index given its name.
    `Observable<Void>` | `dropIndexObservable(String collection, String indexName)` Deprecated. use `rxDropIndex(java.lang.String, java.lang.String)` instead
    `boolean` | `equals(Object o)`
    `MongoClient` | `find(String collection, JsonObject query, Handler<AsyncResult<List<JsonObject>>> resultHandler)` Find matching documents in the specified collection
    `ReadStream<JsonObject>` | `findBatch(String collection, JsonObject query)` Find matching documents in the specified collection.
    `ReadStream<JsonObject>` | `findBatchWithOptions(String collection, JsonObject query, FindOptions options)` Find matching documents in the specified collection, specifying options.
    `Observable<List<JsonObject>>` | `findObservable(String collection, JsonObject query)` Deprecated. use `rxFind(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `findOne(String collection, JsonObject query, JsonObject fields, Handler<AsyncResult<JsonObject>> resultHandler)` Find a single matching document in the specified collection
    `MongoClient` | `findOneAndDelete(String collection, JsonObject query, Handler<AsyncResult<JsonObject>> resultHandler)` Find a single matching document in the specified collection and delete it.
    `Observable<JsonObject>` | `findOneAndDeleteObservable(String collection, JsonObject query)` Deprecated. use `rxFindOneAndDelete(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `findOneAndDeleteWithOptions(String collection, JsonObject query, FindOptions findOptions, Handler<AsyncResult<JsonObject>> resultHandler)` Find a single matching document in the specified collection and delete it.
    `Observable<JsonObject>` | `findOneAndDeleteWithOptionsObservable(String collection, JsonObject query, FindOptions findOptions)` Deprecated. use `rxFindOneAndDeleteWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.FindOptions)` instead
    `MongoClient` | `findOneAndReplace(String collection, JsonObject query, JsonObject replace, Handler<AsyncResult<JsonObject>> resultHandler)` Find a single matching document in the specified collection and replace it.
    `Observable<JsonObject>` | `findOneAndReplaceObservable(String collection, JsonObject query, JsonObject replace)` Deprecated. use `rxFindOneAndReplace(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `findOneAndReplaceWithOptions(String collection, JsonObject query, JsonObject replace, FindOptions findOptions, UpdateOptions updateOptions, Handler<AsyncResult<JsonObject>> resultHandler)` Find a single matching document in the specified collection and replace it.
    `Observable<JsonObject>` | `findOneAndReplaceWithOptionsObservable(String collection, JsonObject query, JsonObject replace, FindOptions findOptions, UpdateOptions updateOptions)` Deprecated. use `rxFindOneAndReplaceWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.FindOptions, io.vertx.ext.mongo.UpdateOptions)` instead
    `MongoClient` | `findOneAndUpdate(String collection, JsonObject query, JsonObject update, Handler<AsyncResult<JsonObject>> resultHandler)` Find a single matching document in the specified collection and update it.
    `Observable<JsonObject>` | `findOneAndUpdateObservable(String collection, JsonObject query, JsonObject update)` Deprecated. use `rxFindOneAndUpdate(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `findOneAndUpdateWithOptions(String collection, JsonObject query, JsonObject update, FindOptions findOptions, UpdateOptions updateOptions, Handler<AsyncResult<JsonObject>> resultHandler)` Find a single matching document in the specified collection and update it.
    `Observable<JsonObject>` | `findOneAndUpdateWithOptionsObservable(String collection, JsonObject query, JsonObject update, FindOptions findOptions, UpdateOptions updateOptions)` Deprecated. use `rxFindOneAndUpdateWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.FindOptions, io.vertx.ext.mongo.UpdateOptions)` instead
    `Observable<JsonObject>` | `findOneObservable(String collection, JsonObject query, JsonObject fields)` Deprecated. use `rxFindOne(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `findWithOptions(String collection, JsonObject query, FindOptions options, Handler<AsyncResult<List<JsonObject>>> resultHandler)` Find matching documents in the specified collection, specifying options
    `Observable<List<JsonObject>>` | `findWithOptionsObservable(String collection, JsonObject query, FindOptions options)` Deprecated. use `rxFindWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.FindOptions)` instead
    `MongoClient` | `getCollections(Handler<AsyncResult<List<String>>> resultHandler)` Get a list of all collections in the database.
    `Observable<List<String>>` | `getCollectionsObservable()` Deprecated. use `rxGetCollections()` instead
    `MongoClient` | `getDelegate()`
    `int` | `hashCode()`
    `MongoClient` | `insert(String collection, JsonObject document, Handler<AsyncResult<String>> resultHandler)` Insert a document in the specified collection
    `Observable<String>` | `insertObservable(String collection, JsonObject document)` Deprecated. use `rxInsert(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `insertWithOptions(String collection, JsonObject document, WriteOption writeOption, Handler<AsyncResult<String>> resultHandler)` Insert a document in the specified collection with the specified write option
    `Observable<String>` | `insertWithOptionsObservable(String collection, JsonObject document, WriteOption writeOption)` Deprecated. use `rxInsertWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
    `MongoClient` | `listIndexes(String collection, Handler<AsyncResult<JsonArray>> resultHandler)` Get all the indexes in this collection.
    `Observable<JsonArray>` | `listIndexesObservable(String collection)` Deprecated. use `rxListIndexes(java.lang.String)` instead
    `static MongoClient` | `newInstance(MongoClient arg)`
    `MongoClient` | `remove(String collection, JsonObject query, Handler<AsyncResult<Void>> resultHandler)` Deprecated.
    `MongoClient` | `removeDocument(String collection, JsonObject query, Handler<AsyncResult<MongoClientDeleteResult>> resultHandler)` Remove a single matching document from a collection and return the handler with MongoClientDeleteResult result
    `Observable<MongoClientDeleteResult>` | `removeDocumentObservable(String collection, JsonObject query)` Deprecated. use `rxRemoveDocument(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `removeDocuments(String collection, JsonObject query, Handler<AsyncResult<MongoClientDeleteResult>> resultHandler)` Remove matching documents from a collection and return the handler with MongoClientDeleteResult result
    `Observable<MongoClientDeleteResult>` | `removeDocumentsObservable(String collection, JsonObject query)` Deprecated. use `rxRemoveDocuments(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `removeDocumentsWithOptions(String collection, JsonObject query, WriteOption writeOption, Handler<AsyncResult<MongoClientDeleteResult>> resultHandler)` Remove matching documents from a collection with the specified write option and return the handler with MongoClientDeleteResult result
    `Observable<MongoClientDeleteResult>` | `removeDocumentsWithOptionsObservable(String collection, JsonObject query, WriteOption writeOption)` Deprecated. use `rxRemoveDocumentsWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
    `MongoClient` | `removeDocumentWithOptions(String collection, JsonObject query, WriteOption writeOption, Handler<AsyncResult<MongoClientDeleteResult>> resultHandler)` Remove a single matching document from a collection with the specified write option and return the handler with MongoClientDeleteResult result
    `Observable<MongoClientDeleteResult>` | `removeDocumentWithOptionsObservable(String collection, JsonObject query, WriteOption writeOption)` Deprecated. use `rxRemoveDocumentWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
    `Observable<Void>` | `removeObservable(String collection, JsonObject query)` Deprecated. use `rxRemove(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `removeOne(String collection, JsonObject query, Handler<AsyncResult<Void>> resultHandler)` Deprecated.
    `Observable<Void>` | `removeOneObservable(String collection, JsonObject query)` Deprecated. use `rxRemoveOne(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `removeOneWithOptions(String collection, JsonObject query, WriteOption writeOption, Handler<AsyncResult<Void>> resultHandler)` Deprecated.
    `Observable<Void>` | `removeOneWithOptionsObservable(String collection, JsonObject query, WriteOption writeOption)` Deprecated. use `rxRemoveOneWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
    `MongoClient` | `removeWithOptions(String collection, JsonObject query, WriteOption writeOption, Handler<AsyncResult<Void>> resultHandler)` Deprecated.
    `Observable<Void>` | `removeWithOptionsObservable(String collection, JsonObject query, WriteOption writeOption)` Deprecated. use `rxRemoveWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
    `MongoClient` | `replace(String collection, JsonObject query, JsonObject replace, Handler<AsyncResult<Void>> resultHandler)` Deprecated.
    `MongoClient` | `replaceDocuments(String collection, JsonObject query, JsonObject replace, Handler<AsyncResult<MongoClientUpdateResult>> resultHandler)` Replace matching documents in the specified collection and return the handler with MongoClientUpdateResult result
    `Observable<MongoClientUpdateResult>` | `replaceDocumentsObservable(String collection, JsonObject query, JsonObject replace)` Deprecated. use `rxReplaceDocuments(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `replaceDocumentsWithOptions(String collection, JsonObject query, JsonObject replace, UpdateOptions options, Handler<AsyncResult<MongoClientUpdateResult>> resultHandler)` Replace matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
    `Observable<MongoClientUpdateResult>` | `replaceDocumentsWithOptionsObservable(String collection, JsonObject query, JsonObject replace, UpdateOptions options)` Deprecated. use `rxReplaceDocumentsWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.UpdateOptions)` instead
    `Observable<Void>` | `replaceObservable(String collection, JsonObject query, JsonObject replace)` Deprecated. use `rxReplace(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `replaceWithOptions(String collection, JsonObject query, JsonObject replace, UpdateOptions options, Handler<AsyncResult<Void>> resultHandler)` Deprecated.
    `Observable<Void>` | `replaceWithOptionsObservable(String collection, JsonObject query, JsonObject replace, UpdateOptions options)` Deprecated. use `rxReplaceWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.UpdateOptions)` instead
    `MongoClient` | `runCommand(String commandName, JsonObject command, Handler<AsyncResult<JsonObject>> resultHandler)` Run an arbitrary MongoDB command.
    `Observable<JsonObject>` | `runCommandObservable(String commandName, JsonObject command)` Deprecated. use `rxRunCommand(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `Single<MongoClientBulkWriteResult>` | `rxBulkWrite(String collection, List<BulkOperation> operations)` Execute a bulk operation.
    `Single<MongoClientBulkWriteResult>` | `rxBulkWriteWithOptions(String collection, List<BulkOperation> operations, BulkWriteOptions bulkWriteOptions)` Execute a bulk operation with the specified write options.
    `Single<Long>` | `rxCount(String collection, JsonObject query)` Count matching documents in a collection.
    `Single<Void>` | `rxCreateCollection(String collectionName)` Create a new collection
    `Single<Void>` | `rxCreateIndex(String collection, JsonObject key)` Creates an index.
    `Single<Void>` | `rxCreateIndexWithOptions(String collection, JsonObject key, IndexOptions options)` Creates an index.
    `Single<JsonArray>` | `rxDistinct(String collection, String fieldName, String resultClassname)` Gets the distinct values of the specified field name.
    `Single<JsonArray>` | `rxDistinctWithQuery(String collection, String fieldName, String resultClassname, JsonObject query)` Gets the distinct values of the specified field name filtered by specified query.
    `Single<Void>` | `rxDropCollection(String collection)` Drop a collection
    `Single<Void>` | `rxDropIndex(String collection, String indexName)` Drops the index given its name.
    `Single<List<JsonObject>>` | `rxFind(String collection, JsonObject query)` Find matching documents in the specified collection
    `Single<JsonObject>` | `rxFindOne(String collection, JsonObject query, JsonObject fields)` Find a single matching document in the specified collection
    `Single<JsonObject>` | `rxFindOneAndDelete(String collection, JsonObject query)` Find a single matching document in the specified collection and delete it.
    `Single<JsonObject>` | `rxFindOneAndDeleteWithOptions(String collection, JsonObject query, FindOptions findOptions)` Find a single matching document in the specified collection and delete it.
    `Single<JsonObject>` | `rxFindOneAndReplace(String collection, JsonObject query, JsonObject replace)` Find a single matching document in the specified collection and replace it.
    `Single<JsonObject>` | `rxFindOneAndReplaceWithOptions(String collection, JsonObject query, JsonObject replace, FindOptions findOptions, UpdateOptions updateOptions)` Find a single matching document in the specified collection and replace it.
    `Single<JsonObject>` | `rxFindOneAndUpdate(String collection, JsonObject query, JsonObject update)` Find a single matching document in the specified collection and update it.
    `Single<JsonObject>` | `rxFindOneAndUpdateWithOptions(String collection, JsonObject query, JsonObject update, FindOptions findOptions, UpdateOptions updateOptions)` Find a single matching document in the specified collection and update it.
    `Single<List<JsonObject>>` | `rxFindWithOptions(String collection, JsonObject query, FindOptions options)` Find matching documents in the specified collection, specifying options
    `Single<List<String>>` | `rxGetCollections()` Get a list of all collections in the database.
    `Single<String>` | `rxInsert(String collection, JsonObject document)` Insert a document in the specified collection
    `Single<String>` | `rxInsertWithOptions(String collection, JsonObject document, WriteOption writeOption)` Insert a document in the specified collection with the specified write option
    `Single<JsonArray>` | `rxListIndexes(String collection)` Get all the indexes in this collection.
    `Single<Void>` | `rxRemove(String collection, JsonObject query)` Deprecated.
    `Single<MongoClientDeleteResult>` | `rxRemoveDocument(String collection, JsonObject query)` Remove a single matching document from a collection and return the handler with MongoClientDeleteResult result
    `Single<MongoClientDeleteResult>` | `rxRemoveDocuments(String collection, JsonObject query)` Remove matching documents from a collection and return the handler with MongoClientDeleteResult result
    `Single<MongoClientDeleteResult>` | `rxRemoveDocumentsWithOptions(String collection, JsonObject query, WriteOption writeOption)` Remove matching documents from a collection with the specified write option and return the handler with MongoClientDeleteResult result
    `Single<MongoClientDeleteResult>` | `rxRemoveDocumentWithOptions(String collection, JsonObject query, WriteOption writeOption)` Remove a single matching document from a collection with the specified write option and return the handler with MongoClientDeleteResult result
    `Single<Void>` | `rxRemoveOne(String collection, JsonObject query)` Deprecated.
    `Single<Void>` | `rxRemoveOneWithOptions(String collection, JsonObject query, WriteOption writeOption)` Deprecated.
    `Single<Void>` | `rxRemoveWithOptions(String collection, JsonObject query, WriteOption writeOption)` Deprecated.
    `Single<Void>` | `rxReplace(String collection, JsonObject query, JsonObject replace)` Deprecated.
    `Single<MongoClientUpdateResult>` | `rxReplaceDocuments(String collection, JsonObject query, JsonObject replace)` Replace matching documents in the specified collection and return the handler with MongoClientUpdateResult result
    `Single<MongoClientUpdateResult>` | `rxReplaceDocumentsWithOptions(String collection, JsonObject query, JsonObject replace, UpdateOptions options)` Replace matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
    `Single<Void>` | `rxReplaceWithOptions(String collection, JsonObject query, JsonObject replace, UpdateOptions options)` Deprecated.
    `Single<JsonObject>` | `rxRunCommand(String commandName, JsonObject command)` Run an arbitrary MongoDB command.
    `Single<String>` | `rxSave(String collection, JsonObject document)` Save a document in the specified collection
    `Single<String>` | `rxSaveWithOptions(String collection, JsonObject document, WriteOption writeOption)` Save a document in the specified collection with the specified write option
    `Single<Void>` | `rxUpdate(String collection, JsonObject query, JsonObject update)` Deprecated.
    `Single<MongoClientUpdateResult>` | `rxUpdateCollection(String collection, JsonObject query, JsonObject update)` Update matching documents in the specified collection and return the handler with MongoClientUpdateResult result
    `Single<MongoClientUpdateResult>` | `rxUpdateCollectionWithOptions(String collection, JsonObject query, JsonObject update, UpdateOptions options)` Update matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
    `Single<Void>` | `rxUpdateWithOptions(String collection, JsonObject query, JsonObject update, UpdateOptions options)` Deprecated.
    `MongoClient` | `save(String collection, JsonObject document, Handler<AsyncResult<String>> resultHandler)` Save a document in the specified collection
    `Observable<String>` | `saveObservable(String collection, JsonObject document)` Deprecated. use `rxSave(java.lang.String, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `saveWithOptions(String collection, JsonObject document, WriteOption writeOption, Handler<AsyncResult<String>> resultHandler)` Save a document in the specified collection with the specified write option
    `Observable<String>` | `saveWithOptionsObservable(String collection, JsonObject document, WriteOption writeOption)` Deprecated. use `rxSaveWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
    `String` | `toString()`
    `MongoClient` | `update(String collection, JsonObject query, JsonObject update, Handler<AsyncResult<Void>> resultHandler)` Deprecated.
    `MongoClient` | `updateCollection(String collection, JsonObject query, JsonObject update, Handler<AsyncResult<MongoClientUpdateResult>> resultHandler)` Update matching documents in the specified collection and return the handler with MongoClientUpdateResult result
    `Observable<MongoClientUpdateResult>` | `updateCollectionObservable(String collection, JsonObject query, JsonObject update)` Deprecated. use `rxUpdateCollection(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `updateCollectionWithOptions(String collection, JsonObject query, JsonObject update, UpdateOptions options, Handler<AsyncResult<MongoClientUpdateResult>> resultHandler)` Update matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
    `Observable<MongoClientUpdateResult>` | `updateCollectionWithOptionsObservable(String collection, JsonObject query, JsonObject update, UpdateOptions options)` Deprecated. use `rxUpdateCollectionWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.UpdateOptions)` instead
    `Observable<Void>` | `updateObservable(String collection, JsonObject query, JsonObject update)` Deprecated. use `rxUpdate(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
    `MongoClient` | `updateWithOptions(String collection, JsonObject query, JsonObject update, UpdateOptions options, Handler<AsyncResult<Void>> resultHandler)` Deprecated.
    `Observable<Void>` | `updateWithOptionsObservable(String collection, JsonObject query, JsonObject update, UpdateOptions options)` Deprecated. use `rxUpdateWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.UpdateOptions)` instead

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<MongoClient> __TYPE_ARG

    - #### DEFAULT_POOL_NAME

          public static final String DEFAULT_POOL_NAME

      The name of the default pool
      See Also:
        Constant Field Values

    - #### DEFAULT_DB_NAME

          public static final String DEFAULT_DB_NAME

      The name of the default database
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MongoClient

          public MongoClient(MongoClient delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public MongoClient getDelegate()

    - #### createNonShared

          public static MongoClient createNonShared(Vertx vertx,
                                                    JsonObject config)

      Create a Mongo client which maintains its own data source.
      Parameters:
        `vertx` - the Vert.x instance
        `config` - the configuration
      Returns:
        the client

    - #### createShared

          public static MongoClient createShared(Vertx vertx,
                                                 JsonObject config,
                                                 String dataSourceName)

      Create a Mongo client which shares its data source with any other Mongo clients created with the same data source name
      Parameters:
        `vertx` - the Vert.x instance
        `config` - the configuration
        `dataSourceName` - the data source name
      Returns:
        the client

    - #### createShared

          public static MongoClient createShared(Vertx vertx,
                                                 JsonObject config)

      Like `createShared(io.vertx.rxjava.core.Vertx, io.vertx.core.json.JsonObject, java.lang.String)` but with the default data source name
      Parameters:
        `vertx` - the Vert.x instance
        `config` - the configuration
      Returns:
        the client

    - #### save

          public MongoClient save(String collection,
                                  JsonObject document,
                                  Handler<AsyncResult<String>> resultHandler)

      Save a document in the specified collection

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
        `resultHandler` - result handler will be provided with the id if document didn't already have one
      Returns:

    - #### saveObservable

          @Deprecated
          public Observable<String> saveObservable(String collection,
                                                               JsonObject document)

      Deprecated. use `rxSave(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Save a document in the specified collection

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
      Returns:

    - #### rxSave

          public Single<String> rxSave(String collection,
                                       JsonObject document)

      Save a document in the specified collection

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
      Returns:

    - #### saveWithOptions

          public MongoClient saveWithOptions(String collection,
                                             JsonObject document,
                                             WriteOption writeOption,
                                             Handler<AsyncResult<String>> resultHandler)

      Save a document in the specified collection with the specified write option

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
        `writeOption` - the write option to use
        `resultHandler` - result handler will be provided with the id if document didn't already have one
      Returns:

    - #### saveWithOptionsObservable

          @Deprecated
          public Observable<String> saveWithOptionsObservable(String collection,
                                                                          JsonObject document,
                                                                          WriteOption writeOption)

      Deprecated. use `rxSaveWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
      Save a document in the specified collection with the specified write option

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
        `writeOption` - the write option to use
      Returns:

    - #### rxSaveWithOptions

          public Single<String> rxSaveWithOptions(String collection,
                                                  JsonObject document,
                                                  WriteOption writeOption)

      Save a document in the specified collection with the specified write option

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
        `writeOption` - the write option to use
      Returns:

    - #### insert

          public MongoClient insert(String collection,
                                    JsonObject document,
                                    Handler<AsyncResult<String>> resultHandler)

      Insert a document in the specified collection

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
        `resultHandler` - result handler will be provided with the id if document didn't already have one
      Returns:

    - #### insertObservable

          @Deprecated
          public Observable<String> insertObservable(String collection,
                                                                 JsonObject document)

      Deprecated. use `rxInsert(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Insert a document in the specified collection

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
      Returns:

    - #### rxInsert

          public Single<String> rxInsert(String collection,
                                         JsonObject document)

      Insert a document in the specified collection

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
      Returns:

    - #### insertWithOptions

          public MongoClient insertWithOptions(String collection,
                                               JsonObject document,
                                               WriteOption writeOption,
                                               Handler<AsyncResult<String>> resultHandler)

      Insert a document in the specified collection with the specified write option

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
        `writeOption` - the write option to use
        `resultHandler` - result handler will be provided with the id if document didn't already have one
      Returns:

    - #### insertWithOptionsObservable

          @Deprecated
          public Observable<String> insertWithOptionsObservable(String collection,
                                                                            JsonObject document,
                                                                            WriteOption writeOption)

      Deprecated. use `rxInsertWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
      Insert a document in the specified collection with the specified write option

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
        `writeOption` - the write option to use
      Returns:

    - #### rxInsertWithOptions

          public Single<String> rxInsertWithOptions(String collection,
                                                    JsonObject document,
                                                    WriteOption writeOption)

      Insert a document in the specified collection with the specified write option

      This operation might change _id field of document parameter

      Parameters:
        `collection` - the collection
        `document` - the document
        `writeOption` - the write option to use
      Returns:

    - #### update

          @Deprecated
          public MongoClient update(String collection,
                                                JsonObject query,
                                                JsonObject update,
                                                Handler<AsyncResult<Void>> resultHandler)

      Deprecated.
      Update matching documents in the specified collection
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
        `resultHandler` - will be called when complete
      Returns:

    - #### updateObservable

          @Deprecated
          public Observable<Void> updateObservable(String collection,
                                                               JsonObject query,
                                                               JsonObject update)

      Deprecated. use `rxUpdate(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
      Update matching documents in the specified collection
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
      Returns:

    - #### rxUpdate

          @Deprecated
          public Single<Void> rxUpdate(String collection,
                                                   JsonObject query,
                                                   JsonObject update)

      Deprecated.
      Update matching documents in the specified collection
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
      Returns:

    - #### updateCollection

          public MongoClient updateCollection(String collection,
                                              JsonObject query,
                                              JsonObject update,
                                              Handler<AsyncResult<MongoClientUpdateResult>> resultHandler)

      Update matching documents in the specified collection and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
        `resultHandler` - will be called when complete
      Returns:

    - #### updateCollectionObservable

          @Deprecated
          public Observable<MongoClientUpdateResult> updateCollectionObservable(String collection,
                                                                                            JsonObject query,
                                                                                            JsonObject update)

      Deprecated. use `rxUpdateCollection(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
      Update matching documents in the specified collection and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
      Returns:

    - #### rxUpdateCollection

          public Single<MongoClientUpdateResult> rxUpdateCollection(String collection,
                                                                    JsonObject query,
                                                                    JsonObject update)

      Update matching documents in the specified collection and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
      Returns:

    - #### updateWithOptions

          @Deprecated
          public MongoClient updateWithOptions(String collection,
                                                           JsonObject query,
                                                           JsonObject update,
                                                           UpdateOptions options,
                                                           Handler<AsyncResult<Void>> resultHandler)

      Deprecated.
      Update matching documents in the specified collection, specifying options
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
        `options` - options to configure the update
        `resultHandler` - will be called when complete
      Returns:

    - #### updateWithOptionsObservable

          @Deprecated
          public Observable<Void> updateWithOptionsObservable(String collection,
                                                                          JsonObject query,
                                                                          JsonObject update,
                                                                          UpdateOptions options)

      Deprecated. use `rxUpdateWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.UpdateOptions)` instead
      Update matching documents in the specified collection, specifying options
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
        `options` - options to configure the update
      Returns:

    - #### rxUpdateWithOptions

          @Deprecated
          public Single<Void> rxUpdateWithOptions(String collection,
                                                              JsonObject query,
                                                              JsonObject update,
                                                              UpdateOptions options)

      Deprecated.
      Update matching documents in the specified collection, specifying options
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
        `options` - options to configure the update
      Returns:

    - #### updateCollectionWithOptions

          public MongoClient updateCollectionWithOptions(String collection,
                                                         JsonObject query,
                                                         JsonObject update,
                                                         UpdateOptions options,
                                                         Handler<AsyncResult<MongoClientUpdateResult>> resultHandler)

      Update matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
        `options` - options to configure the update
        `resultHandler` - will be called when complete
      Returns:

    - #### updateCollectionWithOptionsObservable

          @Deprecated
          public Observable<MongoClientUpdateResult> updateCollectionWithOptionsObservable(String collection,
                                                                                                       JsonObject query,
                                                                                                       JsonObject update,
                                                                                                       UpdateOptions options)

      Deprecated. use `rxUpdateCollectionWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.UpdateOptions)` instead
      Update matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
        `options` - options to configure the update
      Returns:

    - #### rxUpdateCollectionWithOptions

          public Single<MongoClientUpdateResult> rxUpdateCollectionWithOptions(String collection,
                                                                               JsonObject query,
                                                                               JsonObject update,
                                                                               UpdateOptions options)

      Update matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `update` - used to describe how the documents will be updated
        `options` - options to configure the update
      Returns:

    - #### replace

          @Deprecated
          public MongoClient replace(String collection,
                                                 JsonObject query,
                                                 JsonObject replace,
                                                 Handler<AsyncResult<Void>> resultHandler)

      Deprecated.
      Replace matching documents in the specified collection

      This operation might change _id field of replace parameter

      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
        `resultHandler` - will be called when complete
      Returns:

    - #### replaceObservable

          @Deprecated
          public Observable<Void> replaceObservable(String collection,
                                                                JsonObject query,
                                                                JsonObject replace)

      Deprecated. use `rxReplace(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
      Replace matching documents in the specified collection

      This operation might change _id field of replace parameter

      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
      Returns:

    - #### rxReplace

          @Deprecated
          public Single<Void> rxReplace(String collection,
                                                    JsonObject query,
                                                    JsonObject replace)

      Deprecated.
      Replace matching documents in the specified collection

      This operation might change _id field of replace parameter

      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
      Returns:

    - #### replaceDocuments

          public MongoClient replaceDocuments(String collection,
                                              JsonObject query,
                                              JsonObject replace,
                                              Handler<AsyncResult<MongoClientUpdateResult>> resultHandler)

      Replace matching documents in the specified collection and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
        `resultHandler` - will be called when complete
      Returns:

    - #### replaceDocumentsObservable

          @Deprecated
          public Observable<MongoClientUpdateResult> replaceDocumentsObservable(String collection,
                                                                                            JsonObject query,
                                                                                            JsonObject replace)

      Deprecated. use `rxReplaceDocuments(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
      Replace matching documents in the specified collection and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
      Returns:

    - #### rxReplaceDocuments

          public Single<MongoClientUpdateResult> rxReplaceDocuments(String collection,
                                                                    JsonObject query,
                                                                    JsonObject replace)

      Replace matching documents in the specified collection and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
      Returns:

    - #### replaceWithOptions

          @Deprecated
          public MongoClient replaceWithOptions(String collection,
                                                            JsonObject query,
                                                            JsonObject replace,
                                                            UpdateOptions options,
                                                            Handler<AsyncResult<Void>> resultHandler)

      Deprecated.
      Replace matching documents in the specified collection, specifying options

      This operation might change _id field of replace parameter

      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
        `options` - options to configure the replace
        `resultHandler` - will be called when complete
      Returns:

    - #### replaceWithOptionsObservable

          @Deprecated
          public Observable<Void> replaceWithOptionsObservable(String collection,
                                                                           JsonObject query,
                                                                           JsonObject replace,
                                                                           UpdateOptions options)

      Deprecated. use `rxReplaceWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.UpdateOptions)` instead
      Replace matching documents in the specified collection, specifying options

      This operation might change _id field of replace parameter

      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
        `options` - options to configure the replace
      Returns:

    - #### rxReplaceWithOptions

          @Deprecated
          public Single<Void> rxReplaceWithOptions(String collection,
                                                               JsonObject query,
                                                               JsonObject replace,
                                                               UpdateOptions options)

      Deprecated.
      Replace matching documents in the specified collection, specifying options

      This operation might change _id field of replace parameter

      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
        `options` - options to configure the replace
      Returns:

    - #### replaceDocumentsWithOptions

          public MongoClient replaceDocumentsWithOptions(String collection,
                                                         JsonObject query,
                                                         JsonObject replace,
                                                         UpdateOptions options,
                                                         Handler<AsyncResult<MongoClientUpdateResult>> resultHandler)

      Replace matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
        `options` - options to configure the replace
        `resultHandler` - will be called when complete
      Returns:

    - #### replaceDocumentsWithOptionsObservable

          @Deprecated
          public Observable<MongoClientUpdateResult> replaceDocumentsWithOptionsObservable(String collection,
                                                                                                       JsonObject query,
                                                                                                       JsonObject replace,
                                                                                                       UpdateOptions options)

      Deprecated. use `rxReplaceDocumentsWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.UpdateOptions)` instead
      Replace matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
        `options` - options to configure the replace
      Returns:

    - #### rxReplaceDocumentsWithOptions

          public Single<MongoClientUpdateResult> rxReplaceDocumentsWithOptions(String collection,
                                                                               JsonObject query,
                                                                               JsonObject replace,
                                                                               UpdateOptions options)

      Replace matching documents in the specified collection, specifying options and return the handler with MongoClientUpdateResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match the documents
        `replace` - all matching documents will be replaced with this
        `options` - options to configure the replace
      Returns:

    - #### bulkWrite

          public MongoClient bulkWrite(String collection,
                                       List<BulkOperation> operations,
                                       Handler<AsyncResult<MongoClientBulkWriteResult>> resultHandler)

      Execute a bulk operation. Can insert, update, replace, and/or delete multiple documents with one request.
      Parameters:
        `collection` - the collection
        `operations` - the operations to execute
        `resultHandler` - will be called with a `MongoClientBulkWriteResult` when complete
      Returns:

    - #### bulkWriteObservable

          @Deprecated
          public Observable<MongoClientBulkWriteResult> bulkWriteObservable(String collection,
                                                                                        List<BulkOperation> operations)

      Deprecated. use `rxBulkWrite(java.lang.String, java.util.List<io.vertx.ext.mongo.BulkOperation>)` instead
      Execute a bulk operation. Can insert, update, replace, and/or delete multiple documents with one request.
      Parameters:
        `collection` - the collection
        `operations` - the operations to execute
      Returns:

    - #### rxBulkWrite

          public Single<MongoClientBulkWriteResult> rxBulkWrite(String collection,
                                                                List<BulkOperation> operations)

      Execute a bulk operation. Can insert, update, replace, and/or delete multiple documents with one request.
      Parameters:
        `collection` - the collection
        `operations` - the operations to execute
      Returns:

    - #### bulkWriteWithOptions

          public MongoClient bulkWriteWithOptions(String collection,
                                                  List<BulkOperation> operations,
                                                  BulkWriteOptions bulkWriteOptions,
                                                  Handler<AsyncResult<MongoClientBulkWriteResult>> resultHandler)

      Execute a bulk operation with the specified write options. Can insert, update, replace, and/or delete multiple documents with one request.
      Parameters:
        `collection` - the collection
        `operations` - the operations to execute
        `bulkWriteOptions` - the write options
        `resultHandler` - will be called with a `MongoClientBulkWriteResult` when complete
      Returns:

    - #### bulkWriteWithOptionsObservable

          @Deprecated
          public Observable<MongoClientBulkWriteResult> bulkWriteWithOptionsObservable(String collection,
                                                                                                   List<BulkOperation> operations,
                                                                                                   BulkWriteOptions bulkWriteOptions)

      Deprecated. use `rxBulkWriteWithOptions(java.lang.String, java.util.List<io.vertx.ext.mongo.BulkOperation>, io.vertx.ext.mongo.BulkWriteOptions)` instead
      Execute a bulk operation with the specified write options. Can insert, update, replace, and/or delete multiple documents with one request.
      Parameters:
        `collection` - the collection
        `operations` - the operations to execute
        `bulkWriteOptions` - the write options
      Returns:

    - #### rxBulkWriteWithOptions

          public Single<MongoClientBulkWriteResult> rxBulkWriteWithOptions(String collection,
                                                                           List<BulkOperation> operations,
                                                                           BulkWriteOptions bulkWriteOptions)

      Execute a bulk operation with the specified write options. Can insert, update, replace, and/or delete multiple documents with one request.
      Parameters:
        `collection` - the collection
        `operations` - the operations to execute
        `bulkWriteOptions` - the write options
      Returns:

    - #### find

          public MongoClient find(String collection,
                                  JsonObject query,
                                  Handler<AsyncResult<List<JsonObject>>> resultHandler)

      Find matching documents in the specified collection
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `resultHandler` - will be provided with list of documents
      Returns:

    - #### findObservable

          @Deprecated
          public Observable<List<JsonObject>> findObservable(String collection,
                                                                         JsonObject query)

      Deprecated. use `rxFind(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Find matching documents in the specified collection
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:

    - #### rxFind

          public Single<List<JsonObject>> rxFind(String collection,
                                                 JsonObject query)

      Find matching documents in the specified collection
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:

    - #### findBatch

          public ReadStream<JsonObject> findBatch(String collection,
                                                  JsonObject query)

      Find matching documents in the specified collection. This method use batchCursor for returning each found document.
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:
        a emitting found documents

    - #### findWithOptions

          public MongoClient findWithOptions(String collection,
                                             JsonObject query,
                                             FindOptions options,
                                             Handler<AsyncResult<List<JsonObject>>> resultHandler)

      Find matching documents in the specified collection, specifying options
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `options` - options to configure the find
        `resultHandler` - will be provided with list of documents
      Returns:

    - #### findWithOptionsObservable

          @Deprecated
          public Observable<List<JsonObject>> findWithOptionsObservable(String collection,
                                                                                    JsonObject query,
                                                                                    FindOptions options)

      Deprecated. use `rxFindWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.FindOptions)` instead
      Find matching documents in the specified collection, specifying options
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `options` - options to configure the find
      Returns:

    - #### rxFindWithOptions

          public Single<List<JsonObject>> rxFindWithOptions(String collection,
                                                            JsonObject query,
                                                            FindOptions options)

      Find matching documents in the specified collection, specifying options
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `options` - options to configure the find
      Returns:

    - #### findBatchWithOptions

          public ReadStream<JsonObject> findBatchWithOptions(String collection,
                                                             JsonObject query,
                                                             FindOptions options)

      Find matching documents in the specified collection, specifying options. This method use batchCursor for returning each found document.
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `options` - options to configure the find
      Returns:
        a emitting found documents

    - #### findOne

          public MongoClient findOne(String collection,
                                     JsonObject query,
                                     JsonObject fields,
                                     Handler<AsyncResult<JsonObject>> resultHandler)

      Find a single matching document in the specified collection

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `fields` - the fields
        `resultHandler` - will be provided with the document, if any
      Returns:

    - #### findOneObservable

          @Deprecated
          public Observable<JsonObject> findOneObservable(String collection,
                                                                      JsonObject query,
                                                                      JsonObject fields)

      Deprecated. use `rxFindOne(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
      Find a single matching document in the specified collection

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `fields` - the fields
      Returns:

    - #### rxFindOne

          public Single<JsonObject> rxFindOne(String collection,
                                              JsonObject query,
                                              JsonObject fields)

      Find a single matching document in the specified collection

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `fields` - the fields
      Returns:

    - #### findOneAndUpdate

          public MongoClient findOneAndUpdate(String collection,
                                              JsonObject query,
                                              JsonObject update,
                                              Handler<AsyncResult<JsonObject>> resultHandler)

      Find a single matching document in the specified collection and update it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `update` - used to describe how the documents will be updated
        `resultHandler` - will be provided with the document, if any
      Returns:

    - #### findOneAndUpdateObservable

          @Deprecated
          public Observable<JsonObject> findOneAndUpdateObservable(String collection,
                                                                               JsonObject query,
                                                                               JsonObject update)

      Deprecated. use `rxFindOneAndUpdate(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
      Find a single matching document in the specified collection and update it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `update` - used to describe how the documents will be updated
      Returns:

    - #### rxFindOneAndUpdate

          public Single<JsonObject> rxFindOneAndUpdate(String collection,
                                                       JsonObject query,
                                                       JsonObject update)

      Find a single matching document in the specified collection and update it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `update` - used to describe how the documents will be updated
      Returns:

    - #### findOneAndUpdateWithOptions

          public MongoClient findOneAndUpdateWithOptions(String collection,
                                                         JsonObject query,
                                                         JsonObject update,
                                                         FindOptions findOptions,
                                                         UpdateOptions updateOptions,
                                                         Handler<AsyncResult<JsonObject>> resultHandler)

      Find a single matching document in the specified collection and update it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `update` - used to describe how the documents will be updated
        `findOptions` - options to configure the find
        `updateOptions` - options to configure the update
        `resultHandler` - will be provided with the document, if any
      Returns:

    - #### findOneAndUpdateWithOptionsObservable

          @Deprecated
          public Observable<JsonObject> findOneAndUpdateWithOptionsObservable(String collection,
                                                                                          JsonObject query,
                                                                                          JsonObject update,
                                                                                          FindOptions findOptions,
                                                                                          UpdateOptions updateOptions)

      Deprecated. use `rxFindOneAndUpdateWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.FindOptions, io.vertx.ext.mongo.UpdateOptions)` instead
      Find a single matching document in the specified collection and update it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `update` - used to describe how the documents will be updated
        `findOptions` - options to configure the find
        `updateOptions` - options to configure the update
      Returns:

    - #### rxFindOneAndUpdateWithOptions

          public Single<JsonObject> rxFindOneAndUpdateWithOptions(String collection,
                                                                  JsonObject query,
                                                                  JsonObject update,
                                                                  FindOptions findOptions,
                                                                  UpdateOptions updateOptions)

      Find a single matching document in the specified collection and update it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `update` - used to describe how the documents will be updated
        `findOptions` - options to configure the find
        `updateOptions` - options to configure the update
      Returns:

    - #### findOneAndReplace

          public MongoClient findOneAndReplace(String collection,
                                               JsonObject query,
                                               JsonObject replace,
                                               Handler<AsyncResult<JsonObject>> resultHandler)

      Find a single matching document in the specified collection and replace it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `replace` - the replacement document
        `resultHandler` - will be provided with the document, if any
      Returns:

    - #### findOneAndReplaceObservable

          @Deprecated
          public Observable<JsonObject> findOneAndReplaceObservable(String collection,
                                                                                JsonObject query,
                                                                                JsonObject replace)

      Deprecated. use `rxFindOneAndReplace(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject)` instead
      Find a single matching document in the specified collection and replace it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `replace` - the replacement document
      Returns:

    - #### rxFindOneAndReplace

          public Single<JsonObject> rxFindOneAndReplace(String collection,
                                                        JsonObject query,
                                                        JsonObject replace)

      Find a single matching document in the specified collection and replace it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `replace` - the replacement document
      Returns:

    - #### findOneAndReplaceWithOptions

          public MongoClient findOneAndReplaceWithOptions(String collection,
                                                          JsonObject query,
                                                          JsonObject replace,
                                                          FindOptions findOptions,
                                                          UpdateOptions updateOptions,
                                                          Handler<AsyncResult<JsonObject>> resultHandler)

      Find a single matching document in the specified collection and replace it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `replace` - the replacement document
        `findOptions` - options to configure the find
        `updateOptions` - options to configure the update
        `resultHandler` - will be provided with the document, if any
      Returns:

    - #### findOneAndReplaceWithOptionsObservable

          @Deprecated
          public Observable<JsonObject> findOneAndReplaceWithOptionsObservable(String collection,
                                                                                           JsonObject query,
                                                                                           JsonObject replace,
                                                                                           FindOptions findOptions,
                                                                                           UpdateOptions updateOptions)

      Deprecated. use `rxFindOneAndReplaceWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.FindOptions, io.vertx.ext.mongo.UpdateOptions)` instead
      Find a single matching document in the specified collection and replace it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `replace` - the replacement document
        `findOptions` - options to configure the find
        `updateOptions` - options to configure the update
      Returns:

    - #### rxFindOneAndReplaceWithOptions

          public Single<JsonObject> rxFindOneAndReplaceWithOptions(String collection,
                                                                   JsonObject query,
                                                                   JsonObject replace,
                                                                   FindOptions findOptions,
                                                                   UpdateOptions updateOptions)

      Find a single matching document in the specified collection and replace it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `replace` - the replacement document
        `findOptions` - options to configure the find
        `updateOptions` - options to configure the update
      Returns:

    - #### findOneAndDelete

          public MongoClient findOneAndDelete(String collection,
                                              JsonObject query,
                                              Handler<AsyncResult<JsonObject>> resultHandler)

      Find a single matching document in the specified collection and delete it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `resultHandler` - will be provided with the deleted document, if any
      Returns:

    - #### findOneAndDeleteObservable

          @Deprecated
          public Observable<JsonObject> findOneAndDeleteObservable(String collection,
                                                                               JsonObject query)

      Deprecated. use `rxFindOneAndDelete(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Find a single matching document in the specified collection and delete it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
      Returns:

    - #### rxFindOneAndDelete

          public Single<JsonObject> rxFindOneAndDelete(String collection,
                                                       JsonObject query)

      Find a single matching document in the specified collection and delete it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
      Returns:

    - #### findOneAndDeleteWithOptions

          public MongoClient findOneAndDeleteWithOptions(String collection,
                                                         JsonObject query,
                                                         FindOptions findOptions,
                                                         Handler<AsyncResult<JsonObject>> resultHandler)

      Find a single matching document in the specified collection and delete it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `findOptions` - options to configure the find
        `resultHandler` - will be provided with the deleted document, if any
      Returns:

    - #### findOneAndDeleteWithOptionsObservable

          @Deprecated
          public Observable<JsonObject> findOneAndDeleteWithOptionsObservable(String collection,
                                                                                          JsonObject query,
                                                                                          FindOptions findOptions)

      Deprecated. use `rxFindOneAndDeleteWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.FindOptions)` instead
      Find a single matching document in the specified collection and delete it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `findOptions` - options to configure the find
      Returns:

    - #### rxFindOneAndDeleteWithOptions

          public Single<JsonObject> rxFindOneAndDeleteWithOptions(String collection,
                                                                  JsonObject query,
                                                                  FindOptions findOptions)

      Find a single matching document in the specified collection and delete it.

      This operation might change _id field of query parameter

      Parameters:
        `collection` - the collection
        `query` - the query used to match the document
        `findOptions` - options to configure the find
      Returns:

    - #### count

          public MongoClient count(String collection,
                                   JsonObject query,
                                   Handler<AsyncResult<Long>> resultHandler)

      Count matching documents in a collection.
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `resultHandler` - will be provided with the number of matching documents
      Returns:

    - #### countObservable

          @Deprecated
          public Observable<Long> countObservable(String collection,
                                                              JsonObject query)

      Deprecated. use `rxCount(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Count matching documents in a collection.
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:

    - #### rxCount

          public Single<Long> rxCount(String collection,
                                      JsonObject query)

      Count matching documents in a collection.
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:

    - #### remove

          @Deprecated
          public MongoClient remove(String collection,
                                                JsonObject query,
                                                Handler<AsyncResult<Void>> resultHandler)

      Deprecated.
      Remove matching documents from a collection
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `resultHandler` - will be called when complete
      Returns:

    - #### removeObservable

          @Deprecated
          public Observable<Void> removeObservable(String collection,
                                                               JsonObject query)

      Deprecated. use `rxRemove(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Remove matching documents from a collection
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:

    - #### rxRemove

          @Deprecated
          public Single<Void> rxRemove(String collection,
                                                   JsonObject query)

      Deprecated.
      Remove matching documents from a collection
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:

    - #### removeDocuments

          public MongoClient removeDocuments(String collection,
                                             JsonObject query,
                                             Handler<AsyncResult<MongoClientDeleteResult>> resultHandler)

      Remove matching documents from a collection and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `resultHandler` - will be called when complete
      Returns:

    - #### removeDocumentsObservable

          @Deprecated
          public Observable<MongoClientDeleteResult> removeDocumentsObservable(String collection,
                                                                                           JsonObject query)

      Deprecated. use `rxRemoveDocuments(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Remove matching documents from a collection and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:

    - #### rxRemoveDocuments

          public Single<MongoClientDeleteResult> rxRemoveDocuments(String collection,
                                                                   JsonObject query)

      Remove matching documents from a collection and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
      Returns:

    - #### removeWithOptions

          @Deprecated
          public MongoClient removeWithOptions(String collection,
                                                           JsonObject query,
                                                           WriteOption writeOption,
                                                           Handler<AsyncResult<Void>> resultHandler)

      Deprecated.
      Remove matching documents from a collection with the specified write option
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `writeOption` - the write option to use
        `resultHandler` - will be called when complete
      Returns:

    - #### removeWithOptionsObservable

          @Deprecated
          public Observable<Void> removeWithOptionsObservable(String collection,
                                                                          JsonObject query,
                                                                          WriteOption writeOption)

      Deprecated. use `rxRemoveWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
      Remove matching documents from a collection with the specified write option
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `writeOption` - the write option to use
      Returns:

    - #### rxRemoveWithOptions

          @Deprecated
          public Single<Void> rxRemoveWithOptions(String collection,
                                                              JsonObject query,
                                                              WriteOption writeOption)

      Deprecated.
      Remove matching documents from a collection with the specified write option
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `writeOption` - the write option to use
      Returns:

    - #### removeDocumentsWithOptions

          public MongoClient removeDocumentsWithOptions(String collection,
                                                        JsonObject query,
                                                        WriteOption writeOption,
                                                        Handler<AsyncResult<MongoClientDeleteResult>> resultHandler)

      Remove matching documents from a collection with the specified write option and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `writeOption` - the write option to use
        `resultHandler` - will be called when complete
      Returns:

    - #### removeDocumentsWithOptionsObservable

          @Deprecated
          public Observable<MongoClientDeleteResult> removeDocumentsWithOptionsObservable(String collection,
                                                                                                      JsonObject query,
                                                                                                      WriteOption writeOption)

      Deprecated. use `rxRemoveDocumentsWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
      Remove matching documents from a collection with the specified write option and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `writeOption` - the write option to use
      Returns:

    - #### rxRemoveDocumentsWithOptions

          public Single<MongoClientDeleteResult> rxRemoveDocumentsWithOptions(String collection,
                                                                              JsonObject query,
                                                                              WriteOption writeOption)

      Remove matching documents from a collection with the specified write option and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match documents
        `writeOption` - the write option to use
      Returns:

    - #### removeOne

          @Deprecated
          public MongoClient removeOne(String collection,
                                                   JsonObject query,
                                                   Handler<AsyncResult<Void>> resultHandler)

      Deprecated.
      Remove a single matching document from a collection
      Parameters:
        `collection` - the collection
        `query` - query used to match document
        `resultHandler` - will be called when complete
      Returns:

    - #### removeOneObservable

          @Deprecated
          public Observable<Void> removeOneObservable(String collection,
                                                                  JsonObject query)

      Deprecated. use `rxRemoveOne(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Remove a single matching document from a collection
      Parameters:
        `collection` - the collection
        `query` - query used to match document
      Returns:

    - #### rxRemoveOne

          @Deprecated
          public Single<Void> rxRemoveOne(String collection,
                                                      JsonObject query)

      Deprecated.
      Remove a single matching document from a collection
      Parameters:
        `collection` - the collection
        `query` - query used to match document
      Returns:

    - #### removeDocument

          public MongoClient removeDocument(String collection,
                                            JsonObject query,
                                            Handler<AsyncResult<MongoClientDeleteResult>> resultHandler)

      Remove a single matching document from a collection and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match document
        `resultHandler` - will be called when complete
      Returns:

    - #### removeDocumentObservable

          @Deprecated
          public Observable<MongoClientDeleteResult> removeDocumentObservable(String collection,
                                                                                          JsonObject query)

      Deprecated. use `rxRemoveDocument(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Remove a single matching document from a collection and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match document
      Returns:

    - #### rxRemoveDocument

          public Single<MongoClientDeleteResult> rxRemoveDocument(String collection,
                                                                  JsonObject query)

      Remove a single matching document from a collection and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match document
      Returns:

    - #### removeOneWithOptions

          @Deprecated
          public MongoClient removeOneWithOptions(String collection,
                                                              JsonObject query,
                                                              WriteOption writeOption,
                                                              Handler<AsyncResult<Void>> resultHandler)

      Deprecated.
      Remove a single matching document from a collection with the specified write option
      Parameters:
        `collection` - the collection
        `query` - query used to match document
        `writeOption` - the write option to use
        `resultHandler` - will be called when complete
      Returns:

    - #### removeOneWithOptionsObservable

          @Deprecated
          public Observable<Void> removeOneWithOptionsObservable(String collection,
                                                                             JsonObject query,
                                                                             WriteOption writeOption)

      Deprecated. use `rxRemoveOneWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
      Remove a single matching document from a collection with the specified write option
      Parameters:
        `collection` - the collection
        `query` - query used to match document
        `writeOption` - the write option to use
      Returns:

    - #### rxRemoveOneWithOptions

          @Deprecated
          public Single<Void> rxRemoveOneWithOptions(String collection,
                                                                 JsonObject query,
                                                                 WriteOption writeOption)

      Deprecated.
      Remove a single matching document from a collection with the specified write option
      Parameters:
        `collection` - the collection
        `query` - query used to match document
        `writeOption` - the write option to use
      Returns:

    - #### removeDocumentWithOptions

          public MongoClient removeDocumentWithOptions(String collection,
                                                       JsonObject query,
                                                       WriteOption writeOption,
                                                       Handler<AsyncResult<MongoClientDeleteResult>> resultHandler)

      Remove a single matching document from a collection with the specified write option and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match document
        `writeOption` - the write option to use
        `resultHandler` - will be called when complete
      Returns:

    - #### removeDocumentWithOptionsObservable

          @Deprecated
          public Observable<MongoClientDeleteResult> removeDocumentWithOptionsObservable(String collection,
                                                                                                     JsonObject query,
                                                                                                     WriteOption writeOption)

      Deprecated. use `rxRemoveDocumentWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.WriteOption)` instead
      Remove a single matching document from a collection with the specified write option and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match document
        `writeOption` - the write option to use
      Returns:

    - #### rxRemoveDocumentWithOptions

          public Single<MongoClientDeleteResult> rxRemoveDocumentWithOptions(String collection,
                                                                             JsonObject query,
                                                                             WriteOption writeOption)

      Remove a single matching document from a collection with the specified write option and return the handler with MongoClientDeleteResult result
      Parameters:
        `collection` - the collection
        `query` - query used to match document
        `writeOption` - the write option to use
      Returns:

    - #### createCollection

          public MongoClient createCollection(String collectionName,
                                              Handler<AsyncResult<Void>> resultHandler)

      Create a new collection
      Parameters:
        `collectionName` - the name of the collection
        `resultHandler` - will be called when complete
      Returns:

    - #### createCollectionObservable

          @Deprecated
          public Observable<Void> createCollectionObservable(String collectionName)

      Deprecated. use `rxCreateCollection(java.lang.String)` instead
      Create a new collection
      Parameters:
        `collectionName` - the name of the collection
      Returns:

    - #### rxCreateCollection

          public Single<Void> rxCreateCollection(String collectionName)

      Create a new collection
      Parameters:
        `collectionName` - the name of the collection
      Returns:

    - #### getCollections

          public MongoClient getCollections(Handler<AsyncResult<List<String>>> resultHandler)

      Get a list of all collections in the database.
      Parameters:
        `resultHandler` - will be called with a list of collections.
      Returns:

    - #### getCollectionsObservable

          @Deprecated
          public Observable<List<String>> getCollectionsObservable()

      Deprecated. use `rxGetCollections()` instead
      Get a list of all collections in the database.
      Returns:

    - #### rxGetCollections

          public Single<List<String>> rxGetCollections()

      Get a list of all collections in the database.
      Returns:

    - #### dropCollection

          public MongoClient dropCollection(String collection,
                                            Handler<AsyncResult<Void>> resultHandler)

      Drop a collection
      Parameters:
        `collection` - the collection
        `resultHandler` - will be called when complete
      Returns:

    - #### dropCollectionObservable

          @Deprecated
          public Observable<Void> dropCollectionObservable(String collection)

      Deprecated. use `rxDropCollection(java.lang.String)` instead
      Drop a collection
      Parameters:
        `collection` - the collection
      Returns:

    - #### rxDropCollection

          public Single<Void> rxDropCollection(String collection)

      Drop a collection
      Parameters:
        `collection` - the collection
      Returns:

    - #### createIndex

          public MongoClient createIndex(String collection,
                                         JsonObject key,
                                         Handler<AsyncResult<Void>> resultHandler)

      Creates an index.
      Parameters:
        `collection` - the collection
        `key` - A document that contains the field and value pairs where the field is the index key and the value describes the type of index for that field. For an ascending index on a field, specify a value of 1; for descending index, specify a value of -1.
        `resultHandler` - will be called when complete
      Returns:

    - #### createIndexObservable

          @Deprecated
          public Observable<Void> createIndexObservable(String collection,
                                                                    JsonObject key)

      Deprecated. use `rxCreateIndex(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Creates an index.
      Parameters:
        `collection` - the collection
        `key` - A document that contains the field and value pairs where the field is the index key and the value describes the type of index for that field. For an ascending index on a field, specify a value of 1; for descending index, specify a value of -1.
      Returns:

    - #### rxCreateIndex

          public Single<Void> rxCreateIndex(String collection,
                                            JsonObject key)

      Creates an index.
      Parameters:
        `collection` - the collection
        `key` - A document that contains the field and value pairs where the field is the index key and the value describes the type of index for that field. For an ascending index on a field, specify a value of 1; for descending index, specify a value of -1.
      Returns:

    - #### createIndexWithOptions

          public MongoClient createIndexWithOptions(String collection,
                                                    JsonObject key,
                                                    IndexOptions options,
                                                    Handler<AsyncResult<Void>> resultHandler)

      Creates an index.
      Parameters:
        `collection` - the collection
        `key` - A document that contains the field and value pairs where the field is the index key and the value describes the type of index for that field. For an ascending index on a field, specify a value of 1; for descending index, specify a value of -1.
        `options` - the options for the index
        `resultHandler` - will be called when complete
      Returns:

    - #### createIndexWithOptionsObservable

          @Deprecated
          public Observable<Void> createIndexWithOptionsObservable(String collection,
                                                                               JsonObject key,
                                                                               IndexOptions options)

      Deprecated. use `rxCreateIndexWithOptions(java.lang.String, io.vertx.core.json.JsonObject, io.vertx.ext.mongo.IndexOptions)` instead
      Creates an index.
      Parameters:
        `collection` - the collection
        `key` - A document that contains the field and value pairs where the field is the index key and the value describes the type of index for that field. For an ascending index on a field, specify a value of 1; for descending index, specify a value of -1.
        `options` - the options for the index
      Returns:

    - #### rxCreateIndexWithOptions

          public Single<Void> rxCreateIndexWithOptions(String collection,
                                                       JsonObject key,
                                                       IndexOptions options)

      Creates an index.
      Parameters:
        `collection` - the collection
        `key` - A document that contains the field and value pairs where the field is the index key and the value describes the type of index for that field. For an ascending index on a field, specify a value of 1; for descending index, specify a value of -1.
        `options` - the options for the index
      Returns:

    - #### listIndexes

          public MongoClient listIndexes(String collection,
                                         Handler<AsyncResult<JsonArray>> resultHandler)

      Get all the indexes in this collection.
      Parameters:
        `collection` - the collection
        `resultHandler` - will be called when complete
      Returns:

    - #### listIndexesObservable

          @Deprecated
          public Observable<JsonArray> listIndexesObservable(String collection)

      Deprecated. use `rxListIndexes(java.lang.String)` instead
      Get all the indexes in this collection.
      Parameters:
        `collection` - the collection
      Returns:

    - #### rxListIndexes

          public Single<JsonArray> rxListIndexes(String collection)

      Get all the indexes in this collection.
      Parameters:
        `collection` - the collection
      Returns:

    - #### dropIndex

          public MongoClient dropIndex(String collection,
                                       String indexName,
                                       Handler<AsyncResult<Void>> resultHandler)

      Drops the index given its name.
      Parameters:
        `collection` - the collection
        `indexName` - the name of the index to remove
        `resultHandler` - will be called when complete
      Returns:

    - #### dropIndexObservable

          @Deprecated
          public Observable<Void> dropIndexObservable(String collection,
                                                                  String indexName)

      Deprecated. use `rxDropIndex(java.lang.String, java.lang.String)` instead
      Drops the index given its name.
      Parameters:
        `collection` - the collection
        `indexName` - the name of the index to remove
      Returns:

    - #### rxDropIndex

          public Single<Void> rxDropIndex(String collection,
                                          String indexName)

      Drops the index given its name.
      Parameters:
        `collection` - the collection
        `indexName` - the name of the index to remove
      Returns:

    - #### runCommand

          public MongoClient runCommand(String commandName,
                                        JsonObject command,
                                        Handler<AsyncResult<JsonObject>> resultHandler)

      Run an arbitrary MongoDB command.
      Parameters:
        `commandName` - the name of the command
        `command` - the command
        `resultHandler` - will be called with the result.
      Returns:

    - #### runCommandObservable

          @Deprecated
          public Observable<JsonObject> runCommandObservable(String commandName,
                                                                         JsonObject command)

      Deprecated. use `rxRunCommand(java.lang.String, io.vertx.core.json.JsonObject)` instead
      Run an arbitrary MongoDB command.
      Parameters:
        `commandName` - the name of the command
        `command` - the command
      Returns:

    - #### rxRunCommand

          public Single<JsonObject> rxRunCommand(String commandName,
                                                 JsonObject command)

      Run an arbitrary MongoDB command.
      Parameters:
        `commandName` - the name of the command
        `command` - the command
      Returns:

    - #### distinct

          public MongoClient distinct(String collection,
                                      String fieldName,
                                      String resultClassname,
                                      Handler<AsyncResult<JsonArray>> resultHandler)

      Gets the distinct values of the specified field name. Return a JsonArray containing distinct values (eg: [ 1 , 89 ])
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
        `resultHandler` - will be provided with array of values.
      Returns:

    - #### distinctObservable

          @Deprecated
          public Observable<JsonArray> distinctObservable(String collection,
                                                                      String fieldName,
                                                                      String resultClassname)

      Deprecated. use `rxDistinct(java.lang.String, java.lang.String, java.lang.String)` instead
      Gets the distinct values of the specified field name. Return a JsonArray containing distinct values (eg: [ 1 , 89 ])
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
      Returns:

    - #### rxDistinct

          public Single<JsonArray> rxDistinct(String collection,
                                              String fieldName,
                                              String resultClassname)

      Gets the distinct values of the specified field name. Return a JsonArray containing distinct values (eg: [ 1 , 89 ])
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
      Returns:

    - #### distinctWithQuery

          public MongoClient distinctWithQuery(String collection,
                                               String fieldName,
                                               String resultClassname,
                                               JsonObject query,
                                               Handler<AsyncResult<JsonArray>> resultHandler)

      Gets the distinct values of the specified field name filtered by specified query. Return a JsonArray containing distinct values (eg: [ 1 , 89 ])
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
        `query` - the query
        `resultHandler` - will be provided with array of values.
      Returns:

    - #### distinctWithQueryObservable

          @Deprecated
          public Observable<JsonArray> distinctWithQueryObservable(String collection,
                                                                               String fieldName,
                                                                               String resultClassname,
                                                                               JsonObject query)

      Deprecated. use `rxDistinctWithQuery(java.lang.String, java.lang.String, java.lang.String, io.vertx.core.json.JsonObject)` instead
      Gets the distinct values of the specified field name filtered by specified query. Return a JsonArray containing distinct values (eg: [ 1 , 89 ])
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
        `query` - the query
      Returns:

    - #### rxDistinctWithQuery

          public Single<JsonArray> rxDistinctWithQuery(String collection,
                                                       String fieldName,
                                                       String resultClassname,
                                                       JsonObject query)

      Gets the distinct values of the specified field name filtered by specified query. Return a JsonArray containing distinct values (eg: [ 1 , 89 ])
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
        `query` - the query
      Returns:

    - #### distinctBatch

          public ReadStream<JsonObject> distinctBatch(String collection,
                                                      String fieldName,
                                                      String resultClassname)

      Gets the distinct values of the specified field name. This method use batchCursor for returning each found value. Each value is a json fragment with fieldName key (eg: {"num": 1}).
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
      Returns:
        a emitting json fragments

    - #### distinctBatchWithQuery

          public ReadStream<JsonObject> distinctBatchWithQuery(String collection,
                                                               String fieldName,
                                                               String resultClassname,
                                                               JsonObject query)

      Gets the distinct values of the specified field name filtered by specified query. This method use batchCursor for returning each found value. Each value is a json fragment with fieldName key (eg: {"num": 1}).
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
        `query` - the query
      Returns:
        a emitting json fragments

    - #### distinctBatchWithQuery

          public ReadStream<JsonObject> distinctBatchWithQuery(String collection,
                                                               String fieldName,
                                                               String resultClassname,
                                                               JsonObject query,
                                                               int batchSize)

      Gets the distinct values of the specified field name filtered by specified query. This method use batchCursor for returning each found value. Each value is a json fragment with fieldName key (eg: {"num": 1}).
      Parameters:
        `collection` - the collection
        `fieldName` - the field name
        `resultClassname` -
        `query` - the query
        `batchSize` - the number of documents to load in a batch
      Returns:
        a emitting json fragments

    - #### aggregate

          public ReadStream<JsonObject> aggregate(String collection,
                                                  JsonArray pipeline)

      Run aggregate MongoDB command with default `AggregateOptions`.
      Parameters:
        `collection` - the collection
        `pipeline` - aggregation pipeline to be executed
      Returns:

    - #### aggregateWithOptions

          public ReadStream<JsonObject> aggregateWithOptions(String collection,
                                                             JsonArray pipeline,
                                                             AggregateOptions options)

      Run aggregate MongoDB command.
      Parameters:
        `collection` - the collection
        `pipeline` - aggregation pipeline to be executed
        `options` - options to configure the aggregation command
      Returns:

    - #### close

          public void close()

      Close the client and release its resources

    - #### newInstance

          public static MongoClient newInstance(MongoClient arg)

Copyright © 2019 Eclipse. All rights reserved.